C-----------------------------------------------------------------------
C   grasp0.inc
C   This file is INCLUDEd in the grasp0 and angul modules.
C   It is used to set dimensions. 
C
C   MXNC  relativistic CSFs
C   MXNE  exchange terms
C   MXNG  radial grid points for /WAVE/
C   MXNM  angular coefficients
C   MXNO  Lagrange multipliers
C   MXNP  radial grid points
C   MXNW  relativistic orbitals
C   MXNX  dimension for EOL ( = 1 for AL,EAL,OL)
C
C   Note:
C
C   1. angul only uses MXNC, MXNW
C-----------------------------------------------------------------------
      INTEGER MXNC,MXNE,MXNG,MXNM,MXNO,MXNP,MXNW,MXNX
      PARAMETER (MXNC = 440)
      PARAMETER (MXNE = 2000)
      PARAMETER (MXNG = 200000)
      PARAMETER (MXNM = 900000)
      PARAMETER (MXNO = 5000)
      PARAMETER (MXNP = 25000)
      PARAMETER (MXNW = 100)
      PARAMETER (MXNX = 100)
C-----------------------------------------------------------------------
