CEND--------------------------------------------------------------------
CEND    1DSTG0.f    Tue May 19 11:49:28 GMT 1998
CEND--------------------------------------------------------------------
      PROGRAM DSTG0
CRCS
CRCS $Source: D:/DARC/RCS/dstg0.mak $
CRCS $Author: norrington $
CRCS $Date: 1998/05/19 11:49:01 $
CRCS $Revision: 7.4 $
CRCS
CRCS $Log: dstg0.mak $
CRCS Revision 7.4  1998/05/19 11:49:01  norrington
CRCS *** empty log message ***
CRCS
CRCS Revision 7.3  1998/04/24 10:25:14  norrington
CRCS Added common blocks to AAMN0 and improved DMCHK0.
CRCS
CRCS Revision 7.2  1998/04/15 12:22:28  norrington
CRCS Preprocessing has been removed.
CRCS   NP set to 1000
CRCS   P1 set to 100000
CRCS   WM set to 100
CRCS
CRCS Revision 7.1  1998/04/07 12:36:54  norrington
CRCS *** empty log message ***
CRCS
CRCS
C ======================================================================
C
C $Source: D:/DARC/RCS/dstg0.mak $
C $Author: norrington $
C $Date: 1998/05/19 11:49:01 $
C $Revision: 7.4 $
C
C ======================================================================
C
C DARC, the Dirac Atomic R-matrix Codes.
C Version DARC98  April 1998
C
C ======================================================================
C
C DARC has been developed mainly by Patrick Norrington in collaboration
C with Prof Ian Grant FRS. Any inquiries or comments on the package can
C be directed to Dr Norrington at
C
C Department of Applied Mathematics and Theoretical Physics
C The Queen's University of Belfast
C Belfast
C Northern Ireland
C BT7 1NN
C United Kingdom
C
C telephone : (012 32) 273 190
C fax       : (012 32) 239 182
C
C email     : p.norrington@qub.ac.uk
C homepage  : http://www.am.qub.ac.uk/users/p.norrington
C
C DISCLAIMER
C This code has been developed in good faith. The principal
C author believes that it mostly produces reliable results.
C However the user is warned that:
C 1. the code is outdated, the technology is old-fashioned
C    and the code runs slowly, using lots of disc space and
C    is plain inefficient;
C 2. the code contains bugs (hard to find, hairy and horrible);
C 3. nonsense in ---> nonsense out ALWAYS,
C    sense in    ---> nonsense out SOMETIMES.
C Use of this code can cause sleepless nights.
C You have been WARNED.
C
C ======================================================================
C
      CHARACTER*60 SOU,AUT,DAT,REV
      COMMON / INFORM / IREAD,IWRITE
C
C  Set the stream numbers for :
C
C  (1) reading from cards     (IREAD)
C  (2) writing to lineprinter (IWRITE)
C
      IREAD = 5
      IWRITE = 7
C
      OPEN (UNIT=IWRITE,FILE='DSTG0.OUT',STATUS='UNKNOWN')
C
      SOU = '$Source: D:/DARC/RCS/dstg0.mak $'
      AUT = '$Author: norrington $'
      DAT = '$Date: 1998/05/19 11:49:01 $'
      REV = '$Revision: 7.4 $'
      PRINT 3010,SOU,AUT,DAT,REV
      WRITE (IWRITE,3000) SOU,AUT,DAT,REV
      WRITE (IWRITE,3020)
      CALL AAMN0
 3000 FORMAT (/1X,71('*')/1X,A60/1X,A60/1X,A60/1X,A60/1X,71('*')//      !
     +' DARC, the Dirac Atomic R-matrix Codes.'/' DSTG0 module'/        !
     +' Version DARC98  April 1998'/' Coded in double precision FORTRAN'!
     +//' Any inquiries or comments on the code can be directed to'/    !
     +' Dr Patrick Norrington at :'//                                   !
     +' Department of Applied Mathematics and Theoretical Physics'/     !
     +' The Queens University of Belfast'/' Belfast'/' Northern Ireland'!
     +/' BT7 1NN'/' United Kingdom'//' telephone : (012 32) 273 190'/   !
     +' fax       : (012 32) 239 182'/                                  !
     +' email     : p.norrington@qub.ac.uk'/                            !
     +' homepage  : http://www.am.qub.ac.uk/users/p.norrington'//       !
     +' DSTG0 writes the TARGET.INP file needed by DSTG1.'/             !
     +' It can be used interactively.'//1X,71('*'))
 3010 FORMAT (/1X,71('*')/1X,A60/1X,A60/1X,A60/1X,A60/1X,71('*')/       !
     +' DARC, the Dirac Atomic R-matrix Codes.'/' DSTG0 module'/        !
     +' Version DARC98  April 1998'/' Coded in double precision FORTRAN'!
     +/1X,71('*'))
 3020 FORMAT (/' DISCLAIMER'//                                          !
     +' This code has been developed in good faith. The principal'/     !
     +' author believes that it mostly produces reliable results.'/     !
     +' However the user is warned that:'/                              !
     +' 1. the code is outdated, the technology is old-fashioned'/      !
     +'    and the code runs slowly, using lots of disc space and'/     !
     +'    is plain inefficient;'/                                      !
     +' 2. the code contains bugs (hard to find, hairy and horrible);'/ !
     +' 3. nonsense in ---> nonsense out ALWAYS,'/                      !
     +'    sense in    ---> nonsense out SOMETIMES.'/                   !
     +' Use of this code can cause sleepless nights. '/                 !
     +' You have been WARNED.'//1X,71('*'))
      END
CEND--------------------------------------------------------------------
CEND    AAMN0.f    Tue May 19 11:49:28 GMT 1998
CEND--------------------------------------------------------------------
      SUBROUTINE AAMN0
CRCS
CRCS $Source: D:/DARC/RCS/AAMN0.f $
CRCS $Author: norrington $
CRCS $Date: 1998/05/19 11:47:55 $
CRCS $Revision: 7.4 $
CRCS
C-----------------------------------------------------------------------
C
C  This is the main controlling routine for the code.
C
C  This program will read from GRASP dumps and write the formatted
C  file TARGET.INP which is required for DARC DSTG1.
C
C-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*2 NH
      CHARACTER*2 ORBLAB(16)
      LOGICAL LREAD
      LOGICAL EX
C
      COMMON / INFORM / IREAD,IWRITE
      COMMON / MAXDIM / NDIMAX(50)
      COMMON / RECOV  / IDMTST(50)
C
      PARAMETER (ND09=1000)
      PARAMETER (ND14=100000)
      PARAMETER (ND18=100)
C
      DIMENSION DR(ND09),ZZ(ND09)
      DIMENSION NH(ND18),NP(ND18),NAK(ND18),IMCDF(ND18)
      DIMENSION UCF(ND18)
      DIMENSION CP(ND14),CQ(ND14)
C
      DATA ORBLAB/'S ','P-','P ','D-','D ','F-','F ','G-','G ','H-','H '!
     +,'I-','I ','J-','J ','**'/
C-----------------------------------------------------------------------
      JREAD1 = 10
      JREAD2 = 11
      JWRITE = 20
C
      LREAD = .FALSE.
C
      CALL DMSET0(IWRITE)
      WRITE (IWRITE,3020)
C
      PRINT 3000
      WRITE (IWRITE,3000)
C
   10 CONTINUE
      PRINT 3010
      WRITE (IWRITE,3010)
      PRINT 3020
      WRITE (IWRITE,3020)
C
      READ (IREAD,*) IDUMP
      PRINT *,IDUMP
      WRITE (IWRITE,*) IDUMP
      PRINT 3020
      WRITE (IWRITE,3020)
C
      IF (IDUMP.EQ.0) THEN
        PRINT 3140
        WRITE (IWRITE,3140)
        STOP
      ENDIF
C
      IF (IDUMP.LT.0 .OR. IDUMP.GT.3) GOTO 10
C-----------------------------------------------------------------------
      IF (IDUMP.EQ.1) THEN
C
        INQUIRE (FILE='MCDF.DAT',EXIST=EX)
        IF (.NOT.EX) THEN
          PRINT 3100
          WRITE (IWRITE,3100)
          INQUIRE (FILE='BENA.DAT',EXIST=EX)
          IF (.NOT.EX) THEN
            PRINT 3110
            WRITE (IWRITE,3110)
            STOP
          ENDIF
          OPEN (UNIT=JREAD1,FILE='BENA.DAT',FORM='UNFORMATTED',STATUS='O!
     +LD')
        ELSE
          OPEN (UNIT=JREAD1,FILE='MCDF.DAT',FORM='UNFORMATTED',STATUS='O!
     +LD')
        ENDIF
C
        CALL MCDF09(IWRITE,JREAD1,N,DR,ZZ,NW,NH,NP,NAK,IMCDF,UCF,CP,CQ)
C
        LREAD = .TRUE.
C
      ENDIF
C-----------------------------------------------------------------------
      IF (IDUMP.EQ.3) THEN
C
        INQUIRE (FILE='MCDF20.DAT',EXIST=EX)
        IF (.NOT.EX) THEN
          PRINT 3120
          WRITE (IWRITE,3120)
          STOP
        ENDIF
        OPEN (UNIT=JREAD1,FORM='UNFORMATTED',STATUS='OLD',FILE='MCDF20.D!
     +AT')
C
        CALL MCDF20(IWRITE,JREAD1,N,DR,ZZ,NW,NH,NP,NAK,IMCDF,UCF,CP,CQ)
C
        INQUIRE (FILE='MCDF20.INP',EXIST=EX)
        IF (.NOT.EX) THEN
          PRINT 3130
          WRITE (IWRITE,3130)
          STOP
        ENDIF
        OPEN (UNIT=JREAD2,FORM='FORMATTED',STATUS='OLD',FILE='MCDF20.INP!
     +')
C
        DO J = 1,NW
          READ (JREAD2,*,END=20) NP(J),NAK(J)
          IF (NAK(J).LT.0) THEN
            K = -2*NAK(J)-1
          ELSE
            K = 2*NAK(J)
          ENDIF
          IF (K.LT.16) THEN
            NH(J) = ORBLAB(K)
          ELSE
            NH(J) = ORBLAB(16)
          ENDIF
        ENDDO
C
        GOTO 30
C
   20   CONTINUE
        PRINT 3090
        WRITE (IWRITE,3090)
        STOP
C
   30   CONTINUE
        LREAD = .TRUE.
C
      ENDIF
C-----------------------------------------------------------------------
      IF (.NOT.LREAD) THEN
        PRINT 3150
        WRITE (IWRITE,3150)
        STOP
      ENDIF
C-----------------------------------------------------------------------
C
C  Write information about the orbitals.
C
      PRINT 3070
      WRITE (IWRITE,3070)
      DO J = 1,NW
        PRINT 3080,J,NP(J),NH(J),NP(J),NAK(J),UCF(J)
        WRITE (IWRITE,3080) J,NP(J),NH(J),NP(J),NAK(J),UCF(J)
      ENDDO
      PRINT 3020
      WRITE (IWRITE,3020)
C
C  Write the following cards.
C  The cards D to G are repeated for J=1,NW.
C
C  A. NW,N
C  B. (UCF(J),J=1,NW)
C  C. (DR(I),I=1,N)
C
C  D. NP(J),NAK(J)
C  E. (CP(ILAST+I),I=1,N)
C  F. NP(J),NAK(J)
C  G. (CQ(ILAST+I),I=1,N)
C
      INQUIRE (FILE='TARGET.INP',EXIST=EX)
      IF (EX) THEN
        PRINT 3030
        WRITE (IWRITE,3030)
        STOP
      ENDIF
      OPEN (UNIT=JWRITE,FILE='TARGET.INP',STATUS='NEW',FORM='FORMATTED')
C
      WRITE (JWRITE,3040) NW,N
      WRITE (JWRITE,3050) (UCF(J),J=1,NW)
      WRITE (JWRITE,3050) (DR(I),I=1,N)
C
      DO J = 1,NW
        ILAST = IMCDF(J)
        WRITE (JWRITE,3060) NP(J),NAK(J)
        WRITE (JWRITE,3050) (CP(ILAST+I),I=1,N)
        WRITE (JWRITE,3060) NP(J),NAK(J)
        WRITE (JWRITE,3050) (CQ(ILAST+I),I=1,N)
        ILAST = ILAST+N
      ENDDO
C
 3000 FORMAT (/                                                         !
     +' This program will read from a GRASP dump file and write the'/   !
     +' orbitals to a formatted file with the name TARGET.INP. This'/   !
     +' can be used as input to DARC DSTG1. You will be prompted for'/  !
     +' the version of GRASP.')
 3010 FORMAT (/' What is the version of GRASP?'/'   0 = exit'/          !
     +'   1 = version 0.9 (name: MCDF.DAT/BENA.DAT)'/'   2 = version 1'/!
     +'   3 = version 2   (name: MCDF20.DAT and MCDF20.INP)')
 3020 FORMAT (/1X,71('*'))
 3030 FORMAT (/' TARGET.INP exists ... stopping here, no overwrite.')
 3040 FORMAT (1X,2I7)
 3050 FORMAT (1X,1P,4E16.8)
 3060 FORMAT (1X,I4,2X,I4)
 3070 FORMAT (//1X,'orbital',3X,'N',3X,'K   occupation number'/)
 3080 FORMAT (1X,I2,1X,I2,A2,2I4,3X,1P,E13.5)
 3090 FORMAT (/' *********************************************'/        !
     +' ***               WARNING                 ***'/                 !
     +' *** The read statement expects more input ***'/                 !
     +' ***       from JREAD2 (MCDF20.INP).       ***'/                 !
     +' ***     Please check your input data.     ***'/                 !
     +' ***      The code is stopping here.       ***'/                 !
     +' *********************************************')
 3100 FORMAT (/' MCDF.DAT does not exist : try BENA.DAT')
 3110 FORMAT (/' BENA.DAT does not exist : STOPPING')
 3120 FORMAT (/' MCDF20.DAT does not exist : STOPPING')
 3130 FORMAT (/' MCDF20.INP does not exist : STOPPING')
 3140 FORMAT (/' STOPPING as requested.'/)
 3150 FORMAT (/' STOPPING ... no orbitals have been read.'/)
      END
CEND--------------------------------------------------------------------
CEND    DMCHK0.F    Tue May 19 11:49:28 GMT 1998
CEND--------------------------------------------------------------------
      SUBROUTINE DMCHK0(I,ID)
CRCS
CRCS $Source: D:/DARC/RCS/DMCHK0.f $
CRCS $Author: norrington $
CRCS $Date: 1998/04/20 15:08:06 $
CRCS $Revision: 7.3 $
CRCS
C-----------------------------------------------------------------------
C
C This routine is called to test array overflow.
C
C I is the position in the IDMTST array, which holds the current
C    array dimensions
C ID is the array size required by the data.
C
C-----------------------------------------------------------------------
      COMMON / INFORM / IREAD,IWRITE
      COMMON / MAXDIM / NDIMAX(50)
      COMMON / RECOV  / IDMTST(50)
C-----------------------------------------------------------------------
      IF (ID.GT.NDIMAX(I)) NDIMAX(I) = ID
C
      IF (ID.LE.IDMTST(I)) RETURN
C
      PRINT 3000,I,IDMTST(I),I,ID
      WRITE (IWRITE,3000) I,IDMTST(I),I,ID
C
      IF (I.EQ.9) GOTO 10
      IF (I.EQ.14) GOTO 20
      IF (I.EQ.18) GOTO 30
      GOTO 40
C
   10 CONTINUE
      PRINT 3010
      WRITE (IWRITE,3010)
      GOTO 40
C
   20 CONTINUE
      PRINT 3020
      WRITE (IWRITE,3020)
      GOTO 40
C
   30 CONTINUE
      PRINT 3030
      WRITE (IWRITE,3030)
C
   40 CONTINUE
      CALL DMPRT0(IWRITE)
      PRINT 3040
      WRITE (IWRITE,3040)
      STOP
C
 3000 FORMAT (/' *** ARRAY OVERFLOW ***'/                               !
     +' You must increase dimensions given by IDMTST(',I2,')=',I7/      !
     +'                           to at least IDMTST(',I2,')=',I7)
 3010 FORMAT (/' IDMTST(9) contains the dimension of arrays used to'/   !
     +' tabulate the mesh, orbitals and potentials.')
 3020 FORMAT (/' IDMTST(14) contains the maximum value of points'/      !
     +' that can be used for storing orbitals in common block /WAVE/.')
 3030 FORMAT (/                                                         !
     +' IDMTST(18) contains the maximum number of target orbitals.')
 3040 FORMAT (/' program terminates in DMCHK0')
      END
CEND--------------------------------------------------------------------
CEND    DMPRT0.F    Tue May 19 11:49:28 GMT 1998
CEND--------------------------------------------------------------------
      SUBROUTINE DMPRT0(IWRITE)
CRCS
CRCS $Source: D:/DARC/RCS/DMPRT0.f $
CRCS $Author: norrington $
CRCS $Date: 1998/04/15 12:19:37 $
CRCS $Revision: 7.2 $
CRCS
C-----------------------------------------------------------------------
C
C   The following code writes out information on the
C   dimensions used in the code.
C
C-----------------------------------------------------------------------
      COMMON / MAXDIM / NDIMAX(50)
      COMMON / RECOV  / IDMTST(50)
C-----------------------------------------------------------------------
      WRITE (IWRITE,3000)
      WRITE (IWRITE,3010) IDMTST(9),NDIMAX(9)
      WRITE (IWRITE,3020) IDMTST(14),NDIMAX(14)
      WRITE (IWRITE,3030) IDMTST(18),NDIMAX(18)
C-----------------------------------------------------------------------
 3000 FORMAT (/31X,'Subroutine DMPRT0'/31X,'-----------------'//        !
     +' The following information relates to the dimensions set in the',!
     +' code.'/)
 3010 FORMAT (' IDMTST(9)    set to : ',I9,'   maximum used : ',I9)
 3020 FORMAT (' IDMTST(14)   set to : ',I9,'   maximum used : ',I9)
 3030 FORMAT (' IDMTST(18)   set to : ',I9,'   maximum used : ',I9)
      END
CEND--------------------------------------------------------------------
CEND    DMSET0.F    Tue May 19 11:49:28 GMT 1998
CEND--------------------------------------------------------------------
      SUBROUTINE DMSET0(IWRITE)
CRCS
CRCS $Source: D:/DARC/RCS/DMSET0.f $
CRCS $Author: norrington $
CRCS $Date: 1998/04/15 12:19:41 $
CRCS $Revision: 7.2 $
CRCS
C-----------------------------------------------------------------------
      PARAMETER (ND09=1000)
      PARAMETER (ND14=100000)
      PARAMETER (ND18=100)
C
      COMMON / MAXDIM / NDIMAX(50)
      COMMON / RECOV  / IDMTST(50)
C-----------------------------------------------------------------------
      DO I = 1,50
        NDIMAX(I) = -1
        IDMTST(I) = -1
      ENDDO
C-----------------------------------------------------------------------
C
C  IDMTST(9) contains the dimension of arrays used to tabulate mesh,
C  orbitals and potentials.
C  IDMTST(9) is set to ND09=1000.
C
C-----------------------------------------------------------------------
      IDMTST(9) = ND09
C-----------------------------------------------------------------------
C
C  IDMTST(14) is the maximum number of points that can be used for
C  storing orbitals in common block /WAVE/.
C  IDMTST(14) is set to ND14=100000.
C
C-----------------------------------------------------------------------
      IDMTST(14) = ND14
C-----------------------------------------------------------------------
C
C  IDMTST(18) contains the maximum number of target orbitals.
C  IDMTST(18) is set to ND18=100.
C
C-----------------------------------------------------------------------
      IDMTST(18) = ND18
C-----------------------------------------------------------------------
      END
CEND--------------------------------------------------------------------
CEND    MCDF09.F    Tue May 19 11:49:28 GMT 1998
CEND--------------------------------------------------------------------
      SUBROUTINE MCDF09(IWRITE,ITAPE3,N,DR,ZZ,NW,NH,NP,NAK,IMCDF,UCF,CP,!
     +CQ)
CRCS
CRCS $Source: D:/DARC/RCS/MCDF09.f $
CRCS $Author: norrington $
CRCS $Date: 1998/05/19 11:48:04 $
CRCS $Revision: 7.3 $
CRCS
C-----------------------------------------------------------------------
C
C  Read GRASP MCDF dump using stream ITAPE3.
C
C-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*2 NH
      CHARACTER IHEDIN*80,RECIN*20
C
      PARAMETER (ND09=1000)
      PARAMETER (ND14=100000)
      PARAMETER (ND18=100)
C
      DIMENSION DR(ND09),ZZ(ND09)
      DIMENSION NH(ND18),NP(ND18),NAK(ND18),IMCDF(ND18)
      DIMENSION UCF(ND18)
      DIMENSION CP(ND14),CQ(ND14)
C
      PARAMETER (ZERO=0.D0)
C-----------------------------------------------------------------------
C
C   An extra point is included for the wave-functions
C   and nuclear potential at r=0.
C
C-----------------------------------------------------------------------
      READ (ITAPE3) IHEDIN,RECIN
      READ (ITAPE3) NCMIN,NW,NCF,N
      READ (ITAPE3) Z,RNT,H,C
C
      WRITE (IWRITE,3000) IHEDIN(1:40),IHEDIN(41:80),RECIN
      WRITE (IWRITE,3020) NCMIN,NW,NCF,N
      WRITE (IWRITE,3030) Z,RNT,H,C
C
      IF (Z.LT.ZERO) THEN
        PRINT 3010
        WRITE (IWRITE,3010)
        STOP
      ENDIF
C
      CALL DMCHK0(18,NW)
      CALL DMCHK0(9,N+1)
C
      ILAST = 0
      DO I = 1,NW
        IMCDF(I) = ILAST
        READ (ITAPE3) NH(I),NP(I),NAK(I),E
        READ (ITAPE3)
        CALL DMCHK0(14,ILAST+1+N)
        CP(ILAST+1) = ZERO
        CQ(ILAST+1) = ZERO
        READ (ITAPE3) (CP(ILAST+1+J),J=1,N), (CQ(ILAST+1+J),J=1,N)
        ILAST = ILAST+1+N
      ENDDO
C
      READ (ITAPE3)
      READ (ITAPE3) (UCF(I),I=1,NW)
C
      IF (NCMIN.GT.0) THEN
        READ (ITAPE3)
        READ (ITAPE3)
      ENDIF
C
      READ (ITAPE3)
      READ (ITAPE3)
      READ (ITAPE3) NEC
C
      IF (NEC.GT.0) THEN
        READ (ITAPE3)
      ENDIF
C
      READ (ITAPE3) NUCTYP
C
      IF (NUCTYP.EQ.0) THEN
        ZZ(1) = Z
      ELSE
        ZZ(1) = ZERO
      ENDIF
C
      READ (ITAPE3) (ZZ(I+1),I=1,N)
C
      CLOSE (ITAPE3)
C-----------------------------------------------------------------------
C
C  Set the logarithmic mesh
C
C-----------------------------------------------------------------------
      EPH = EXP(H)
      RR = RNT
      DR(1) = ZERO
      DO I = 1,N
        DR(I+1) = RR
        RR = RR*EPH
      ENDDO
      N = N+1
C-----------------------------------------------------------------------
      STEP1 = DR(2)-DR(1)
      STEP2 = DR(N)-DR(N-1)
      WRITE (IWRITE,3040) N,H,EPH,DR(1),DR(N),STEP1,STEP2
C-----------------------------------------------------------------------
 3000 FORMAT (/' Read GRASP dump with title :'//1X,A40/1X,A40/1X,A20//  !
     +' GRASP problem'/' -------------')
 3010 FORMAT (/' ********************************************'/         !
     +' *** WARNING : code is stopping in MCDF09 ***'/                  !
     +' ***       unconverged GRASP dump         ***'/                  !
     +' ********************************************')
 3020 FORMAT (/' NCMIN (MCDF calculation type)        : ',I6/           !
     +' NW    (orbitals)                     : ',I6/                    !
     +' NCF   (configurations)               : ',I6/                    !
     +' N     (log. mesh number of points)   : ',I6)
 3030 FORMAT (' Z     (atomic number)                : ',F7.2/          !
     +' RNT   (log. mesh 1st point)          : ',1P,E14.7/              !
     +' H     (log. mesh step-size)          : ',E14.7/                 !
     +' C     (speed of light)               : ',E14.7)
 3040 FORMAT (/'  Logarithmic mesh is defined as follows :'//           !
     +'  number of points (N) = ',I4/'  stepsize         (H) = ',1P,E12.!
     +5/'  EXP(H)               = ',E12.5/'  first mesh point     = ',E1!
     +2.5/'  last  mesh point     = ',E12.5/'  initial stepsize     = ',!
     +E12.5/'  final   stepsize     = ',E12.5)
      END
CEND--------------------------------------------------------------------
CEND    MCDF20.F    Tue May 19 11:49:28 GMT 1998
CEND--------------------------------------------------------------------
      SUBROUTINE MCDF20(IWRITE,ITAPE3,N,DR,ZZ,NW,NH,NP,NAK,IMCDF,UCF,CP,!
     +CQ)
CRCS
CRCS $Source: D:/DARC/RCS/MCDF20.f $
CRCS $Author: norrington $
CRCS $Date: 1998/05/19 11:48:10 $
CRCS $Revision: 7.3 $
CRCS
C-----------------------------------------------------------------------
C
C  Read GRASP2 MCDF dump using stream ITAPE3.
C
C-----------------------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*2 NH
      CHARACTER*72 IHED
      CHARACTER*8 ITIME,IDATE
      CHARACTER*4 GTYPE,GSTAT
C
      PARAMETER (ND09=1000)
      PARAMETER (ND14=100000)
      PARAMETER (ND18=100)
C
      DIMENSION DR(ND09),ZZ(ND09)
      DIMENSION NH(ND18),NP(ND18),NAK(ND18),IMCDF(ND18)
      DIMENSION UCF(ND18)
      DIMENSION CP(ND14),CQ(ND14)
C
      PARAMETER (ZERO=0.D0)
C-----------------------------------------------------------------------
C
C   IHED is the title of the run.
C   ITIME is the time at execution.
C   IDATE is the date at execution.
C   GTYPE is 'MCDF'.
C   GSTAT is 'ITER' or 'CONV'
C
C-----------------------------------------------------------------------
      REWIND ITAPE3
C
      READ (ITAPE3) IHED,ITIME,IDATE,GTYPE,GSTAT
      READ (ITAPE3) NW,NCF
      READ (ITAPE3) ACCY,ATW,C,CON1,CON2,Z
C
      WRITE (IWRITE,3000) ITAPE3,IHED,ITIME,IDATE,GTYPE,GSTAT
      WRITE (IWRITE,3010) NW,NCF
      WRITE (IWRITE,3020) ACCY,ATW,C,CON1,CON2,Z
C
      READ (ITAPE3)
      READ (ITAPE3) RNT,H,HP,N, (DR(I),I=1,N), (ZZ(I),I=1,N),(ZZ(I),I=1,!
     +N)
      WRITE (IWRITE,3030) RNT,H,HP,N
C
      CALL DMCHK0(18,NW)
      CALL DMCHK0(9,N)
C-----------------------------------------------------------------------
C
C  read in the orbitals
C
C-----------------------------------------------------------------------
      ILAST = 0
C
      DO J = 1,NW
        IMCDF(J) = ILAST
        CALL DMCHK0(14,ILAST+N)
C
        READ (ITAPE3) E,PZ,MFJ
        READ (ITAPE3) (CP(ILAST+I),I=1,MFJ), (CQ(ILAST+I),I=1,MFJ)
C
        IF (MFJ.LT.N) THEN
          DO I = MFJ+1,N
            CP(ILAST+I) = ZERO
            CQ(ILAST+I) = ZERO
          ENDDO
        ENDIF
C
        ILAST = ILAST+N
C
      ENDDO
C
      READ (ITAPE3)
      READ (ITAPE3)
      READ (ITAPE3) (UCF(J),J=1,NW)
C
      CLOSE (ITAPE3)
C
      EPH = EXP(H)
C-----------------------------------------------------------------------
      STEP1 = DR(2)-DR(1)
      STEP2 = DR(N)-DR(N-1)
      WRITE (IWRITE,3040) N,H,EPH,DR(1),DR(N),STEP1,STEP2
C-----------------------------------------------------------------------
 3000 FORMAT (/' Read GRASP2 MCDF dump from stream ITAPE3 (',I2,') :'// !
     +' IHED        : ',A72/' ITIME,IDATE : ',A8,1X,A8/' GTYPE       : '!
     +,A4/' GSTAT       : ',A4/)
 3010 FORMAT (/' NW    (orbitals)                     : ',I6/           !
     +' NCF   (configurations)               : ',I6)
 3020 FORMAT (/' ACCY  (MCDF calculation type)        : ',1P,E14.7/     !
     +' ATW   (atomic weight)                : ',E14.7/                 !
     +' C     (speed of light)               : ',E14.7/                 !
     +' CON1                                 : ',E14.7/                 !
     +' CON2                                 : ',E14.7/                 !
     +' Z     (atomic number)                : ',0P,F7.2)
 3030 FORMAT (/' RNT   (log. mesh 1st point)          : ',1P,E14.7/     !
     +' H     (log. mesh step-size)          : ',E14.7/                 !
     +' HP                                   : ',E14.7/                 !
     +' N     (log. mesh number of points)   : ',I6)
 3040 FORMAT (/'  Logarithmic mesh is defined as follows :'//           !
     +'  number of points (N) = ',I4/'  stepsize         (H) = ',1P,E12.!
     +5/'  EXP(H)               = ',E12.5/'  first mesh point     = ',E1!
     +2.5/'  last  mesh point     = ',E12.5/'  initial stepsize     = ',!
     +E12.5/'  final   stepsize     = ',E12.5)
      END
